// Output generated from file: D:/fractal/Fragmentarium/Output/Sabine/cubicquatabs4D/1.frag
// Created: Fri Aug 25 01:09:24 2017
#define providesInit

//#define USE_IQ_CLOUDS
#define MULTI_SAMPLE_AO
#define KN_VOLUMETRIC
#define USE_EIFFIE_SHADOW
#include "DE-Kn2cr11.frag"
//#include "DE-Raytracer.frag"
#include "MathUtils.frag"

#group CubicQuad
uniform float cz; slider[-2,0,2]
uniform int Iterations;  slider[0,16,100]
uniform int ColorIterations;  slider[0,16,100]
uniform vec4 C; slider[(-5,-5,-5,-5),(0,0,0,0),(5,5,5,5)]
uniform float X_mul; slider[-5,1,5]
uniform float Y_mul; slider[-5,1,5]
uniform float Z_mul; slider[-5,1,5]
uniform float W_mul; slider[-5,1,5]
uniform float W_add; slider[-5,0,5]
uniform float X_twist; slider[-5,0,5]
uniform float Y_twist; slider[-5,0,5]
uniform bool Abs4D; checkbox[false]
uniform vec3 RotVector; slider[(0,0,0),(1,1,1),(1,1,1)]
uniform float RotAngle; slider[0.00,0,180]

mat3 rot;
void init() {
	rot = rotationMatrix3(normalize(RotVector), RotAngle);
}

float DE(vec3 pos) {
	vec4 p = vec4(pos, cz);
	p.yzw*=rot;
	vec4 dp = vec4(1.0,0.0,0.0,0.0);
	for (int i = 0; i < Iterations; i++) {
		p.x = X_mul * p.x*p.x - (Y_mul * p.y*p.y + Z_mul *p.z*p.z + W_mul * p.w*p.w) + C.x + C.y * X_twist; 		//this is the cubicquat-bit taken from dark-beam's mb3d formula
		p.y = 2*Y_mul * p.x*p.y + C.y + C.x * Y_twist; 																					//  							   "
		p.z = 2*Z_mul * p.x*p.z + C.z;																											//                        "
		p.w = 2*W_mul * p.x*p.w + W_add + C.w;																								//                        "
		if (Abs4D) (p=abs(p));																														//Together with this line we should get a burning ship (does work in mb3d, tip by Pupkuusikko)
		dp = 2.0* vec4(p.x*dp.x-dot(p.yzw, dp.yzw), p.x*dp.yzw+dp.x*p.yzw+cross(p.yzw, dp.yzw));							//stolen from QuaternionMandelbrot4D.frag in fragmentarium\examples\experimental, dp needed for DE..?
		p = vec4(p.x*p.x-dot(p.yzw, p.yzw), vec3(2.0*p.x*p.yzw)) +  vec4(pos, 0.0);											//									"
		float p2 = dot(p,p);																														//									"
		if (i<ColorIterations) orbitTrap = min(orbitTrap, abs(vec4(p.xyz,p2)));
		
	}
	float r = length(p);
	return  0.5 * r * log(r)/ length(dp);
}



#preset Default
FOV = 0.395066
Eye = -0.5627134,3.230119,-0.2348207
Target = 0.6313225,-3.230568,-0.4706733
Up = -0.049125,0.0271658,-0.9928516
EquiRectangular = false
FocalPlane = 3.413075
Aperture = 0
InFocusAWidth = 0
DofCorrect = true
ApertureNbrSides = 7
ApertureRot = 0
ApStarShaped = true
Gamma = 1
ToneMapping = 5
Exposure = 1
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Bloom = false
BloomIntensity = 0
BloomPow = 2
BloomTaps = 4
BloomStrong = 1
DepthToAlpha = false
ShowDepth = false
DepthMagnitude = 7.548543
Detail = -2.638952
RefineSteps = 4
FudgeFactor = 0.0235849
MaxRaySteps = 5000
MaxDistance = 20
Dither = 0
NormalBackStep = 1
DetailAO = -0.5
coneApertureAO = 0.307601
maxIterAO = 14
FudgeAO = 0.6309795
AO_ambient = 1.782407
AO_camlight = 1.7219
AO_pointlight = 1.776224
AoCorrect = 0.9668192
Specular = 0.4
SpecularExp = 16
CamLight = 1,0.9294118,0.8666667,0.1393152
AmbiantLight = 0.8313725,0.972549,1,0.26538
Reflection = 0.1882353,0.172549,0.1529412
ReflectionsNumber = 1
SpotGlow = true
SpotLight = 1,0.9254902,0.7411765,0
LightPos = -0.5355064,0.209546,0.4889406
LightSize = 0
LightFallOff = 0.7423888
LightGlowRad = 0.6398104
LightGlowExp = 0.4023669
HardShadow = 0.8431604
ShadowSoft = 0
ShadowBlur = 0
perf = false
SSS = false
sss1 = 0.1
sss2 = 0.3231982
BaseColor = 0.3686275,0.3686275,0.3686275
OrbitStrength = 0.9857651
X = 0.5,0.6,0.6,1
Y = 1,0.6,0,1
Z = 0.8,0.78,1,1
R = 0.4,0.7,1,0.7293921
BackgroundColor = 0.8901961,0.9607843,0.9803922
GradientBackground = 0.5110837
CycleColors = true
Cycles = 2.906422
EnableFloor = false NotLocked
FloorNormal = 0,0,1
FloorHeight = 0.2199074
FloorColor = 1,0.5058824,0.01176471
HF_Fallof = 1.684359
HF_Const = 0
HF_Intensity = 0
HF_Dir = 0,0,1
HF_Offset = -4.299176
HF_Color = 0,1,1,2.571429
HF_Scatter = 1.012956
HF_Anisotropy = 0,0,0
HF_FogIter = 5
HF_CastShadow = true
EnCloudsDir = false
CloudDir = 0,0,1
CloudScale = 1
CloudFlatness = 0
CloudTops = 1
CloudBase = -1
CloudDensity = 1
CloudRoughness = 1
CloudContrast = 1
CloudColor = 0.65,0.68,0.7
CloudColor2 = 0.07,0.17,0.24
SunLightColor = 0.7,0.5,0.3
Cloudvar1 = 0.99
Cloudvar2 = 1
CloudIter = 5
CloudBgMix = 1
WindDir = 0,0,1
WindSpeed = 1
cz = 0
Iterations = 6
ColorIterations = 3
C = 0,0,0,0
X_mul = 1
Y_mul = 1
Z_mul = 1
W_mul = 1
W_add = 0
X_twist = 0
Y_twist = 0
Abs4D = false
RotVector = 1,1,1
RotAngle = 0
#endpreset

